/*

    Portable generic functions
    Copyright (C) 2004 Jussi Laako

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>


#ifndef GENERIC_HH
    #define GENERIC_HH


    inline void uSleep (long lUSecs)
        {
            struct timeval sTimeVal;
            
            sTimeVal.tv_sec = lUSecs / 1000000L;
            sTimeVal.tv_usec = lUSecs % 1000000L;
            select(0, NULL, NULL, NULL, &sTimeVal);
        }

#endif
